Qt 5.11 | Qt 3D | C++ Classes | QRayCaster

Qt 5.11.3 Reference Documentation

# QRayCaster Class

(Qt3DRender::QRayCaster)

Qt3DRender::QRayCaster is used to perform ray casting tests in 3d world coordinates. More...

Header: | #include <QRayCaster>
qmake: | QT += 3drender
Since: | Qt 5.11
Instantiated By: | RayCaster
Inherits: | Qt3DRender::QAbstractRayCaster

- List of all members, including inherited members

## Properties

- direction : QVector3D
- length : float
- origin : QVector3D

- 3 properties inherited from Qt3DRender::QAbstractRayCaster
- 1 property inherited from Qt3DCore::QComponent
- 3 properties inherited from Qt3DCore::QNode

## Public Functions

| QRayCaster(Qt3DCore::QNode *parent = nullptr)
QVector3D | direction() const
float | length() const
QVector3D | origin() const

- 6 public functions inherited from Qt3DRender::QAbstractRayCaster
- 2 public functions inherited from Qt3DCore::QComponent
- 13 public functions inherited from Qt3DCore::QNode

## Public Slots

void | setDirection(const QVector3D &direction)
void | setLength(float length)
void | setOrigin(const QVector3D &origin)
void | trigger()
void | trigger(const QVector3D &origin, const QVector3D &direction, float length)

- 2 public slots inherited from Qt3DRender::QAbstractRayCaster
- 1 public slot inherited from Qt3DCore::QComponent
- 3 public slots inherited from Qt3DCore::QNode

## Signals

void | directionChanged(const QVector3D &direction)
void | lengthChanged(float length)
void | originChanged(const QVector3D &origin)

- 3 signals inherited from Qt3DRender::QAbstractRayCaster
- 3 signals inherited from Qt3DCore::QComponent
- 4 signals inherited from Qt3DCore::QNode

## Protected Functions

| QRayCaster(Qt3DRender::QAbstractRayCasterPrivate &dd, Qt3DCore::QNode *parent = nullptr)

- 2 protected functions inherited from Qt3DCore::QNode

## Detailed Description

Qt3DRender::QRayCaster is used to perform ray casting tests in 3d world coordinates.

The 3d ray is defined by its origin, direction and length. It will be affected by the transformations applied to the entity it belongs to.

Ray casting tests will be performed every frame as long as the component is enabled. The hits property will be updated with the list of intersections.

See also QAbstractRayCaster and QScreenRayCaster.

## Property Documentation

### direction : QVector3D

Holds the direction of the 3D ray. This should be a unit vector.

Access functions:

QVector3D | direction() const
void | setDirection(const QVector3D &direction)

Notifier signal:

void | directionChanged(const QVector3D &direction)

### length : float

Holds the length of the 3D ray.

Access functions:

float | length() const
void | setLength(float length)

Notifier signal:

void | lengthChanged(float length)

### origin : QVector3D

Holds the origin of the 3D ray in local coordinates.

Access functions:

QVector3D | origin() const
void | setOrigin(const QVector3D &origin)

Notifier signal:

void | originChanged(const QVector3D &origin)

## Member Function Documentation

### QRayCaster::QRayCaster(Qt3DCore::QNode *parent = nullptr)

Default constructs an instance of QRayCaster.

### `[protected]` QRayCaster::QRayCaster(Qt3DRender::QAbstractRayCasterPrivate &dd, Qt3DCore::QNode *parent = nullptr)

Default constructs an instance of QRayCaster.

### `[slot]` void QRayCaster::setLength(float length)

Sets the length of the ray to length.

If the value is less than or equal to zero, the ray is concidered to be infinite.

Note: Setter function for property length.

See also length().

### `[slot]` void QRayCaster::trigger()

Convenience method to enable the component and trigger tests using the current ray.

### `[slot]` void QRayCaster::trigger(const QVector3D &origin, const QVector3D &direction, float length)

Convenience method to set the ray details origin, direction, and length, and enable the component to trigger tests.